Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Olympus.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Olympus.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Olympus.pm	(revision 34921)
@@ -1904,4 +2465,7 @@
                     2 => 'FL',
                     3 => 'MF',
+                    4 => 'ISO', #forum8906
+                    5 => 'AE Auto', #forum8906
+                    6 => 'Focus', #PH
                 }) . ' Bracketing';
                 $a =~ s/, /+/g;
@@ -1915,5 +2479,5 @@
                 $a = $a{$a} || "Unknown ($a)";
             }
-            return "$a, Shot $b";
+            return "$a, Shot $b$e";
         },
     },
@@ -1931,5 +2495,5 @@
                 4 => 'Top to Bottom',
             );
-            return ($a{$a} || "Unknown ($a)") . ', Shot ' . $b;
+            return(($a{$a} || "Unknown ($a)") . ', Shot ' . $b);
         },
     },
@@ -1955,4 +2519,43 @@
             2 => 'On, Mode 2',
             3 => 'On, Mode 3',
+            4 => 'On, Mode 4', # (NC, E-P5)
+        },
+    },
+    0x804 => { #PH (E-M1 with firmware update)
+        Name => 'StackedImage',
+        Writable => 'int32u',
+        Count => 2,
+        PrintConv => {
+            '0 0' => 'No',
+            '1 *' => 'Live Composite (* images)', #24
+            '4 *' => 'Live Time/Bulb (* images)', #24
+            '3 2' => 'ND2 (1EV)', #IB
+            '3 4' => 'ND4 (2EV)', #IB
+            '3 8' => 'ND8 (3EV)', #IB
+            '3 16' => 'ND16 (4EV)', #IB
+            '3 32' => 'ND32 (5EV)', #IB
+            '5 4' => 'HDR1', #forum8906
+            '6 4' => 'HDR2', #forum8906
+            '8 8' => 'Tripod high resolution', #IB
+            '9 *' => 'Focus-stacked (* images)', #IB (* = 2-15)
+            '11 16' => 'Hand-held high resolution', #IB (perhaps '11 15' would be possible, ref 24)
+            OTHER => sub {
+                my ($val, $inv, $conv) = @_;
+                if ($inv) {
+                    $val = lc $val;
+                    return undef unless $val =~ s/(\d+) images/\* images/;
+                    my $num = $1;
+                    foreach (keys %$conv) {
+                        next unless $val eq lc $$conv{$_};
+                        ($val = $_) =~ s/\*/$num/ or return undef;
+                        return $val;
+                    }
+                } else {
+                    return "Unknown ($_[0])" unless $val =~ s/ (\d+)/ \*/ and $$conv{$val};
+                    my $num = $1;
+                    ($val = $$conv{$val}) =~ s/\*/$num/;
+                    return $val;
+                }
+            },
         },
     },
@@ -1981,12 +2584,27 @@
     },
     0x903 => { #11
-        Name => 'LevelGaugeRoll',
-        Writable => 'int16u',
-        PrintConv => \%offOn,
+        Name => 'RollAngle',
+        Notes => 'converted to degrees of clockwise camera rotation',
+        Writable => 'int16s',
+        Count => 2, # (second value is 0 if level gauge is off)
+        # negate to express as clockwise rotation
+        ValueConv => '$val=~s/ 1$// ? -$val/10 : "n/a"',
+        ValueConvInv => 'IsFloat($val) ? sprintf("%.0f 1",-$val*10) : "0 0"',
     },
     0x904 => { #11
-        Name => 'LevelGaugePitch',
-        Writable => 'int16u',
-        PrintConv => \%offOn,
+        Name => 'PitchAngle',
+        Notes => 'converted to degrees of upward camera tilt',
+        Writable => 'int16s',
+        Count => 2, # (second value is 0 if level gauge is off)
+        ValueConv => '$val =~ s/ 1$// ? $val / 10 : "n/a"',
+        ValueConvInv => 'IsFloat($val) ? sprintf("%.0f 1",$val*10) : "0 0"',
+    },
+    0x908 => { #PH (NC, E-M1)
+        Name => 'DateTimeUTC',
+        Writable => 'string',
+        Groups => { 2 => 'Time' },
+        Shift => 'Time',
+        PrintConv => '$self->ConvertDateTime($val)',
+        PrintConvInv => '$self->InverseDateTime($val,undef,1)',
     },
 );
@@ -2004,40 +2622,12 @@
         Count => 4,
     },
-    0x100 => {
-        Name => 'RawDevExposureBiasValue',
-        Writable => 'rational64s',
-    },
-    0x101 => {
-        Name => 'RawDevWhiteBalanceValue',
-        Writable => 'int16u',
-    },
-    0x102 => {
-        Name => 'RawDevWBFineAdjustment',
-        Writable => 'int16s',
-    },
-    0x103 => {
-        Name => 'RawDevGrayPoint',
-        Writable => 'int16u',
-        Count => 3,
-    },
-    0x104 => {
-        Name => 'RawDevSaturationEmphasis',
-        Writable => 'int16s',
-        Count => 3,
-    },
-    0x105 => {
-        Name => 'RawDevMemoryColorEmphasis',
-        Writable => 'int16u',
-    },
-    0x106 => {
-        Name => 'RawDevContrastValue',
-        Writable => 'int16s',
-        Count => 3,
-    },
-    0x107 => {
-        Name => 'RawDevSharpnessValue',
-        Writable => 'int16s',
-        Count => 3,
-    },
+    0x100 => { Name => 'RawDevExposureBiasValue',   Writable => 'rational64s' },
+    0x101 => { Name => 'RawDevWhiteBalanceValue',   Writable => 'int16u' },
+    0x102 => { Name => 'RawDevWBFineAdjustment',    Writable => 'int16s' },
+    0x103 => { Name => 'RawDevGrayPoint',           Writable => 'int16u', Count => 3 },
+    0x104 => { Name => 'RawDevSaturationEmphasis',  Writable => 'int16s', Count => 3 },
+    0x105 => { Name => 'RawDevMemoryColorEmphasis', Writable => 'int16u' },
+    0x106 => { Name => 'RawDevContrastValue',       Writable => 'int16s', Count => 3 },
+    0x107 => { Name => 'RawDevSharpnessValue',      Writable => 'int16s', Count => 3 },
     0x108 => {
         Name => 'RawDevColorSpace',
@@ -2063,4 +2653,5 @@
         Writable => 'int16u',
         PrintConv => { #11
+            0 => '(none)',
             BITMASK => {
                 0 => 'Noise Reduction',
@@ -2084,4 +2675,5 @@
         Writable => 'int16u',
         PrintConv => { #11
+            0 => '(none)',
             BITMASK => {
                 0 => 'WB Color Temp',
@@ -2110,8 +2702,5 @@
         Count => 4,
     },
-    0x100 => {
-        Name => 'RawDevExposureBiasValue',
-        Writable => 'rational64s',
-    },
+    0x100 => { Name => 'RawDevExposureBiasValue',   Writable => 'rational64s' },
     0x101 => {
         Name => 'RawDevWhiteBalance',
@@ -2122,36 +2711,11 @@
         },
     },
-    0x102 => {
-        Name => 'RawDevWhiteBalanceValue',
-        Writable => 'int16u',
-    },
-    0x103 => {
-        Name => 'RawDevWBFineAdjustment',
-        Writable => 'int16s',
-    },
-    0x104 => {
-        Name => 'RawDevGrayPoint',
-        Writable => 'int16u',
-        Count => 3,
-    },
-    0x105 => {
-        Name => 'RawDevContrastValue',
-        Writable => 'int16s',
-        Count => 3,
-    },
-    0x106 => {
-        Name => 'RawDevSharpnessValue',
-        Writable => 'int16s',
-        Count => 3,
-    },
-    0x107 => {
-        Name => 'RawDevSaturationEmphasis',
-        Writable => 'int16s',
-        Count => 3,
-    },
-    0x108 => {
-        Name => 'RawDevMemoryColorEmphasis',
-        Writable => 'int16u',
-    },
+    0x102 => { Name => 'RawDevWhiteBalanceValue',   Writable => 'int16u' },
+    0x103 => { Name => 'RawDevWBFineAdjustment',    Writable => 'int16s' },
+    0x104 => { Name => 'RawDevGrayPoint',           Writable => 'int16u', Count => 3 },
+    0x105 => { Name => 'RawDevContrastValue',       Writable => 'int16s', Count => 3 },
+    0x106 => { Name => 'RawDevSharpnessValue',      Writable => 'int16s', Count => 3 },
+    0x107 => { Name => 'RawDevSaturationEmphasis',  Writable => 'int16s', Count => 3 },
+    0x108 => { Name => 'RawDevMemoryColorEmphasis', Writable => 'int16u' },
     0x109 => {
         Name => 'RawDevColorSpace',
@@ -2167,4 +2731,5 @@
         Writable => 'int16u',
         PrintConv => {
+            0 => '(none)',
             BITMASK => {
                 0 => 'Noise Reduction',
@@ -2193,19 +2758,7 @@
         },
     },
-    0x10d => {
-        Name => 'RawDevPMSaturation',
-        Writable => 'int16s',
-        Count => 3,
-    },
-    0x10e => {
-        Name => 'RawDevPMContrast',
-        Writable => 'int16s',
-        Count => 3,
-    },
-    0x10f => {
-        Name => 'RawDevPMSharpness',
-        Writable => 'int16s',
-        Count => 3,
-    },
+    0x10d => { Name => 'RawDevPMSaturation',    Writable => 'int16s', Count => 3 },
+    0x10e => { Name => 'RawDevPMContrast',      Writable => 'int16s', Count => 3 },
+    0x10f => { Name => 'RawDevPMSharpness',     Writable => 'int16s', Count => 3 },
     0x110 => {
         Name => 'RawDevPM_BWFilter',
@@ -2230,22 +2783,14 @@
         },
     },
-    0x112 => {
-        Name => 'RawDevGradation',
-        Writable => 'int16s',
-        Count => 3,
-    },
-    0x113 => {
-        Name => 'RawDevSaturation3',
-        Writable => 'int16s',
-        Count => 3, #(NC)
-    },
-    0x119 => {
-        Name => 'RawDevAutoGradation',
-        Writable => 'int16u', #(NC)
-        PrintConv => \%offOn,
-    },
-    0x120 => {
-        Name => 'RawDevPMNoiseFilter',
-        Writable => 'int16u', #(NC)
+    0x112 => { Name => 'RawDevGradation',       Writable => 'int16s', Count => 3 },
+    0x113 => { Name => 'RawDevSaturation3',     Writable => 'int16s', Count => 3 }, #(NC Count)
+    0x119 => { Name => 'RawDevAutoGradation',   Writable => 'int16u', PrintConv => \%offOn },
+    0x120 => { Name => 'RawDevPMNoiseFilter',   Writable => 'int16u' }, #(NC format)
+    0x121 => { #PH (E-P5)
+        Name => 'RawDevArtFilter',
+        Writable => 'int16u',
+        Count => 4,
+        PrintConvColumns => 2,
+        PrintConv => [ \%filters ],
     },
 );
@@ -2263,141 +2808,37 @@
         Count => 4,
     },
-    0x100 => { #6
-        Name => 'WB_RBLevels',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x102 => { #11
-        Name => 'WB_RBLevels3000K',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x103 => { #11
-        Name => 'WB_RBLevels3300K',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x104 => { #11
-        Name => 'WB_RBLevels3600K',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x105 => { #11
-        Name => 'WB_RBLevels3900K',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x106 => { #11
-        Name => 'WB_RBLevels4000K',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x107 => { #11
-        Name => 'WB_RBLevels4300K',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x108 => { #11
-        Name => 'WB_RBLevels4500K',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x109 => { #11
-        Name => 'WB_RBLevels4800K',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x10a => { #11
-        Name => 'WB_RBLevels5300K',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x10b => { #11
-        Name => 'WB_RBLevels6000K',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x10c => { #11
-        Name => 'WB_RBLevels6600K',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x10d => { #11
-        Name => 'WB_RBLevels7500K',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x10e => { #11
-        Name => 'WB_RBLevelsCWB1',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x10f => { #11
-        Name => 'WB_RBLevelsCWB2',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x110 => { #11
-        Name => 'WB_RBLevelsCWB3',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x111 => { #11
-        Name => 'WB_RBLevelsCWB4',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x113 => { #11
-        Name => 'WB_GLevel3000K',
-        Writable => 'int16u',
-    },
-    0x114 => { #11
-        Name => 'WB_GLevel3300K',
-        Writable => 'int16u',
-    },
-    0x115 => { #11
-        Name => 'WB_GLevel3600K',
-        Writable => 'int16u',
-    },
-    0x116 => { #11
-        Name => 'WB_GLevel3900K',
-        Writable => 'int16u',
-    },
-    0x117 => { #11
-        Name => 'WB_GLevel4000K',
-        Writable => 'int16u',
-    },
-    0x118 => { #11
-        Name => 'WB_GLevel4300K',
-        Writable => 'int16u',
-    },
-    0x119 => { #11
-        Name => 'WB_GLevel4500K',
-        Writable => 'int16u',
-    },
-    0x11a => { #11
-        Name => 'WB_GLevel4800K',
-        Writable => 'int16u',
-    },
-    0x11b => { #11
-        Name => 'WB_GLevel5300K',
-        Writable => 'int16u',
-    },
-    0x11c => { #11
-        Name => 'WB_GLevel6000K',
-        Writable => 'int16u',
-    },
-    0x11d => { #11
-        Name => 'WB_GLevel6600K',
-        Writable => 'int16u',
-    },
-    0x11e => { #11
-        Name => 'WB_GLevel7500K',
-        Writable => 'int16u',
-    },
-    0x11f => { #11
-        Name => 'WB_GLevel',
-        Writable => 'int16u',
-    },
+    0x100 => { Name => 'WB_RBLevels',       Writable => 'int16u', Count => 2 }, #6
+    # 0x101 - in-camera AutoWB unless it is all 0's or all 256's (ref IB)
+    0x102 => { Name => 'WB_RBLevels3000K',  Writable => 'int16u', Count => 2 }, #11
+    0x103 => { Name => 'WB_RBLevels3300K',  Writable => 'int16u', Count => 2 }, #11
+    0x104 => { Name => 'WB_RBLevels3600K',  Writable => 'int16u', Count => 2 }, #11
+    0x105 => { Name => 'WB_RBLevels3900K',  Writable => 'int16u', Count => 2 }, #11
+    0x106 => { Name => 'WB_RBLevels4000K',  Writable => 'int16u', Count => 2 }, #11
+    0x107 => { Name => 'WB_RBLevels4300K',  Writable => 'int16u', Count => 2 }, #11
+    0x108 => { Name => 'WB_RBLevels4500K',  Writable => 'int16u', Count => 2 }, #11
+    0x109 => { Name => 'WB_RBLevels4800K',  Writable => 'int16u', Count => 2 }, #11
+    0x10a => { Name => 'WB_RBLevels5300K',  Writable => 'int16u', Count => 2 }, #11
+    0x10b => { Name => 'WB_RBLevels6000K',  Writable => 'int16u', Count => 2 }, #11
+    0x10c => { Name => 'WB_RBLevels6600K',  Writable => 'int16u', Count => 2 }, #11
+    0x10d => { Name => 'WB_RBLevels7500K',  Writable => 'int16u', Count => 2 }, #11
+    0x10e => { Name => 'WB_RBLevelsCWB1',   Writable => 'int16u', Count => 2 }, #11
+    0x10f => { Name => 'WB_RBLevelsCWB2',   Writable => 'int16u', Count => 2 }, #11
+    0x110 => { Name => 'WB_RBLevelsCWB3',   Writable => 'int16u', Count => 2 }, #11
+    0x111 => { Name => 'WB_RBLevelsCWB4',   Writable => 'int16u', Count => 2 }, #11
+    0x113 => { Name => 'WB_GLevel3000K',    Writable => 'int16u' }, #11
+    0x114 => { Name => 'WB_GLevel3300K',    Writable => 'int16u' }, #11
+    0x115 => { Name => 'WB_GLevel3600K',    Writable => 'int16u' }, #11
+    0x116 => { Name => 'WB_GLevel3900K',    Writable => 'int16u' }, #11
+    0x117 => { Name => 'WB_GLevel4000K',    Writable => 'int16u' }, #11
+    0x118 => { Name => 'WB_GLevel4300K',    Writable => 'int16u' }, #11
+    0x119 => { Name => 'WB_GLevel4500K',    Writable => 'int16u' }, #11
+    0x11a => { Name => 'WB_GLevel4800K',    Writable => 'int16u' }, #11
+    0x11b => { Name => 'WB_GLevel5300K',    Writable => 'int16u' }, #11
+    0x11c => { Name => 'WB_GLevel6000K',    Writable => 'int16u' }, #11
+    0x11d => { Name => 'WB_GLevel6600K',    Writable => 'int16u' }, #11
+    0x11e => { Name => 'WB_GLevel7500K',    Writable => 'int16u' }, #11
+    0x11f => { Name => 'WB_GLevel',         Writable => 'int16u' }, #11
+    # 0x121 = WB preset for flash (about 6000K) (ref IB)
+    # 0x125 = WB preset for underwater (ref IB)
     0x200 => { #6
         Name => 'ColorMatrix',
@@ -2414,56 +2855,37 @@
     # 0x0253-0x0255 are Adobe RGB color matrices
     # 0x0256-0x0258 are ProPhoto RGB color matrices
-    0x300 => { #11
-        Name => 'Enhancer',
-        Writable => 'int16u',
-    },
-    0x301 => { #11
-        Name => 'EnhancerValues',
-        Writable => 'int16u',
-        Count => 7,
-    },
-    0x310 => { #11
-        Name => 'CoringFilter',
-        Writable => 'int16u',
-    },
-    0x0311 => { #11
-        Name => 'CoringValues',
-        Writable => 'int16u',
-        Count => 7,
-    },
-    0x600 => { #11
-        Name => 'BlackLevel2',
-        Writable => 'int16u',
-        Count => 4,
-    },
-    0x610 => { #11
-        Name => 'GainBase',
-        Writable => 'int16u',
-    },
-    0x611 => { #4/6
-        Name => 'ValidBits',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x612 => { #11
-        Name => 'CropLeft',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x613 => { #11
-        Name => 'CropTop',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x614 => { #PH/11
-        Name => 'CropWidth',
-        Writable => 'int32u',
-    },
-    0x615 => { #PH/11
-        Name => 'CropHeight',
-        Writable => 'int32u',
+    0x300 => { Name => 'Enhancer',          Writable => 'int16u' }, #11
+    0x301 => { Name => 'EnhancerValues',    Writable => 'int16u', Count => 7 }, #11
+    0x310 => { Name => 'CoringFilter',      Writable => 'int16u' }, #11
+    0x311 => { Name => 'CoringValues',      Writable => 'int16u', Count => 7 }, #11
+    0x600 => { Name => 'BlackLevel2',       Writable => 'int16u', Count => 4 }, #11
+    0x610 => { Name => 'GainBase',          Writable => 'int16u' }, #11
+    0x611 => { Name => 'ValidBits',         Writable => 'int16u', Count => 2 }, #4/6
+    0x612 => { Name => 'CropLeft',          Writable => 'int16u', Count => 2 }, #11
+    0x613 => { Name => 'CropTop',           Writable => 'int16u', Count => 2 }, #11
+    0x614 => { Name => 'CropWidth',         Writable => 'int32u' }, #PH/11
+    0x615 => { Name => 'CropHeight',        Writable => 'int32u' }, #PH/11
+    0x635 => { #PH (data starts with "CMIO\x01\0")
+        Name => 'UnknownBlock1',
+        Writable => 'undef',
+        Notes => 'large unknown data block in ORF images but not JPG images',
+        # 'Drop' because too large for APP1 in JPEG images
+        Flags => [ 'Unknown', 'Binary', 'Drop' ],
+    },
+    0x636 => { #PH (data starts with "CMIO\x01\0")
+        Name => 'UnknownBlock2',
+        Writable => 'undef',
+        Notes => 'large unknown data block in ORF images but not JPG images',
+        # 'Drop' because too large for APP1 in JPEG images
+        Flags => [ 'Unknown', 'Binary', 'Drop' ],
     },
     # 0x800 LensDistortionParams, float[9] (ref 11)
     # 0x801 LensShadingParams, int16u[16] (ref 11)
+    0x0805 => { #IB
+        Name => 'SensorCalibration',
+        Notes => '2 numbers: 1. Recommended maximum, 2. Calibration midpoint',
+        Writable => 'int16s',
+        Count => 2,
+    },
     # 0x1010-0x1012 are the processing options used in camera or in
     # Olympus software, which 0x050a-0x050c are in-camera only (ref 6)
@@ -2472,4 +2894,5 @@
         Writable => 'int16u',
         PrintConv => {
+            0 => '(none)',
             BITMASK => {
                 0 => 'Noise Reduction',
@@ -2495,4 +2918,5 @@
         PrintConv => [{
             0 => 'Off',
+            1 => 'Live Composite', #github issue#61
             2 => 'On (2 frames)',
             3 => 'On (3 frames)',
@@ -2500,7 +2924,14 @@
     },
     0x1103 => { #PH
-        Name => 'UnknownBlock',
+        Name => 'UnknownBlock3',
         Writable => 'undef',
-        Notes => 'unknown 142kB block in ORF images, not copied to JPEG images',
+        Notes => 'large unknown data block in ORF images but not JPG images',
+        # 'Drop' because too large for APP1 in JPEG images
+        Flags => [ 'Unknown', 'Binary', 'Drop' ],
+    },
+    0x1104 => { #PH (overlaps data for 0x1103 in E-M5 ORF images)
+        Name => 'UnknownBlock4',
+        Writable => 'undef',
+        Notes => 'large unknown data block in ORF images but not JPG images',
         # 'Drop' because too large for APP1 in JPEG images
         Flags => [ 'Unknown', 'Binary', 'Drop' ],
@@ -2511,7 +2942,12 @@
         Count => 2,
         PrintConv => {
+            # '0 0' - have seen this with a 16:9 XZ-1 image - PH
             '1 1' => '4:3',
+            '1 4' => '1:1', #PH (E-P5 Storyboard effect, does this indicate 4:3 converted to 6:6?)
+            '2 1' => '3:2 (RAW)', #forum6285
             '2 2' => '3:2',
+            '3 1' => '16:9 (RAW)', #forum6285
             '3 3' => '16:9',
+            '4 1' => '1:1 (RAW)', #forum6285
             '4 4' => '6:6',
             '5 5' => '5:4',
@@ -2519,12 +2955,9 @@
             '7 7' => '6:5',
             '8 8' => '7:5',
+            '9 1' => '3:4 (RAW)', #forum6285
             '9 9' => '3:4',
         },
     },
-    0x1113 => { #11
-        Name => 'AspectFrame',
-        Writable => 'int16u',
-        Count => 4,
-    },
+    0x1113 => { Name => 'AspectFrame',  Writable => 'int16u', Count => 4 }, #11
     0x1200 => { #11/PH
         Name => 'FacesDetected',
@@ -2545,9 +2978,5 @@
         },
     },
-    0x1202 => { #PH
-        Name => 'MaxFaces',
-        Writable => 'int32u',
-        Count => 3,
-    },
+    0x1202 => { Name => 'MaxFaces',     Writable => 'int32u', Count => 3 }, #PH
     0x1203 => { #PH
         Name => 'FaceDetectFrameSize',
@@ -2561,4 +2990,37 @@
         Count => 12,
         Notes => 'X/Y offset and width/height of the cropped face detect frame',
+    },
+    0x1306 => { #PH (NC, E-M1)
+        Name => 'CameraTemperature',
+        Writable => 'int16u',
+        Format => 'int16s', #(NC)
+        ValueConv => '$val ? $val : undef', # zero for some models (how to differentiate from 0 C?)
+        Notes => 'this seems to be in degrees C only for some models',
+    },
+    0x1900 => { #23
+        Name => 'KeystoneCompensation',
+        Writable => 'int8u',
+        Count => 2,
+        PrintConv => {
+            '0 0' => 'Off',
+            '0 1' => 'On',
+        },
+    },
+    0x1901 => { #23
+        Name => 'KeystoneDirection',
+        Writable => 'int8u',
+        Count => 2,
+        PrintConv => {
+            0 => 'Vertical',
+            1 => 'Horizontal',
+        },
+    },
+    # 0x1905 - focal length (PH, E-M1)
+    0x1906 => { #23
+        Name => 'KeystoneValue',
+        Writable => 'int16s',
+        Count => 3,
+        # (use in conjunction with KeystoneDirection, -ve is Top or Right, +ve is Bottom or Left)
+        Notes => '3 numbers: 1. Keystone Value, 2. Min, 3. Max',
     },
 );
@@ -2582,8 +3044,5 @@
         Unknown => 1, #6
     },
-    0x210 => { #11
-        Name => 'SceneDetect',
-        Writable => 'int16u',
-    },
+    0x210 => { Name => 'SceneDetect',       Writable => 'int16u' }, #11
     0x211 => { #11
         Name => 'SceneArea',
@@ -2599,20 +3058,9 @@
         Unknown => 1, # (but what does it mean?)
     },
-    0x300 => { #6
-        Name => 'ZoomStepCount',
-        Writable => 'int16u',
-    },
-    0x301 => { #11
-        Name => 'FocusStepCount',
-        Writable => 'int16u',
-    },
-    0x303 => { #11
-        Name => 'FocusStepInfinity',
-        Writable => 'int16u',
-    },
-    0x304 => { #11
-        Name => 'FocusStepNear',
-        Writable => 'int16u',
-    },
+    # 0x214 - int16u: normally 0, but 1 for E-M1 focus-bracketing, and have seen 1 and 256 at other times
+    0x300 => { Name => 'ZoomStepCount',     Writable => 'int16u' }, #6
+    0x301 => { Name => 'FocusStepCount',    Writable => 'int16u' }, #11
+    0x303 => { Name => 'FocusStepInfinity', Writable => 'int16u' }, #11
+    0x304 => { Name => 'FocusStepNear',     Writable => 'int16u' }, #11
     0x305 => { #4
         Name => 'FocusDistance',
@@ -2649,4 +3097,5 @@
             ValueConv => '($val & 0x1f) . " " . ($val & 0xffe0)',
             ValueConvInv => 'my @v=split(" ",$val); @v == 2 ? $v[0] + $v[1] : $val',
+            PrintConvColumns => 2,
             PrintConv => [
                 {
@@ -2674,4 +3123,5 @@
                     0x15 => 'Bottom-center (vertical)',
                     0x16 => 'Bottom-right (vertical)',
+                    0x1f => 'n/a', #PH (NC, E-3)
                 },
                 {
@@ -2679,4 +3129,5 @@
                     0x40 => 'All Target',
                     0x80 => 'Dynamic Single Target',
+                    0xe0 => 'n/a', #PH (NC, E-3)
                 }
             ],
@@ -2716,12 +3167,8 @@
     ],
     # 0x31a Continuous AF parameters?
-    # 0x328 Related to AF (maybe Imager AF data?) (ref PH, E-PL1):
-    #  - offset 0x2a (int8u)  ImagerAFMode?  0=Manual, 1=Auto
-    #  - offset 0x30 (int16u) AFAreaXPosition
-    #  - offset 0x32 (int16u) AFAreaWidth (202)
-    #  - offset 0x34 (int16u) AFAreaYPosition
-    #  - offset 0x36 (int16u) AFAreaHeight (50)
-    #  (AF area positions above give the top-left coordinates of the AF area in the
-    #   AF frame. Increasing Y is downwards, and the AF frame size is about 1280x256)
+    0x328 => { #PH
+        Name => 'AFInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::Olympus::AFInfo' },
+    },
     # 0x1200-0x1209 Flash information:
     0x1201 => { #6
@@ -2747,8 +3194,5 @@
         },
     },
-    0x1205 => { #11 (ref converts to mm using table)
-        Name => 'ExternalFlashZoom',
-        Writable => 'rational64u',
-    },
+    0x1205 => { Name => 'ExternalFlashZoom', Writable => 'rational64u' }, #11 (ref converts to mm using table)
     0x1208 => { #6
         Name => 'InternalFlash',
@@ -2774,12 +3218,47 @@
         },
     },
-    0x1500 => { #6
+    0x120a => { #PH
+        Name => 'MacroLED',
+        Writable => 'int16u',
+        PrintConv => \%offOn,
+    },
+    0x1500 => [{ #6
+        Name => 'SensorTemperature',
+        # (Stylus 1 stores values like "34 0 0")
+        Condition => '$$self{Model} =~ /E-(1|M5)\b/ || $count != 1',
+        Writable => 'int16s',
+        PrintConv => '$val=~s/ 0 0$//; "$val C"',
+        PrintConvInv => '$val=~s/ ?C$//; $val',
+    },{
         Name => 'SensorTemperature',
         Writable => 'int16s',
-        Notes => q{
-            approximately Celsius for E-1, unknown calibration for E-3/410/420/510, and
-            always zero for E-300/330/400/500, divide by 10 for E-P1?
-        },
-    },
+        RawConv => '($val and $val ne "-32768") ? $val : undef', # ignore 0 and -32768
+        # ValueConv => '-2*(($val/135)**2)+55', #11
+        ValueConv => '84 - 3 * $val / 26', #https://exiftool.org/forum/index.php/topic,5423.0.html
+        ValueConvInv => 'int((84 - $val) * 26 / 3 + 0.5)',
+        PrintConv => 'sprintf("%.1f C",$val)',
+        PrintConvInv => '$val=~s/ ?C$//; $val',
+        # data from test shots by Eric Sibert:
+        #    E-510           E-620
+        # Raw  Ambient    Raw  Ambient
+        # ---  -------    ---  -------
+        # 534    22.7     518    22.7
+        # 550    20.6     531    19.3
+        # 552    20.8     533    17.9
+        # 558    19.3     582    17.2
+        # 564    19.1     621    12.3
+        # 567    17.8     634     9.7
+        # 576    18.6     650     8.0
+        # 582    17.2     660     7.7
+        # 599    13.8     703     3.3
+        # 631    10.7     880   -20.6
+        # 642    12.4     880   -20.6
+        # 652     9.6     892   -24.4
+        # 692     5.2     892   -22.7
+        # 714     3.3
+        # 895   -19.8
+        # 895   -19.2
+        # 900   -21.7
+    }],
     0x1600 => { # ref http://fourthirdsphoto.com/vbb/showpost.php?p=107607&postcount=15
         Name => 'ImageStabilization',
@@ -2797,9 +3276,23 @@
 );
 
+# AF information (ref PH)
+%Image::ExifTool::Olympus::AFInfo = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    FIRST_ENTRY => 0,
+    # 0x2a - int8u:  ImagerAFMode?  0=Manual, 1=Auto
+    # 0x30 - int16u: AFAreaXPosition?
+    # 0x32 - int16u: AFAreaWidth? (202)
+    # 0x34 - int16u: AFAreaYPosition?
+    # 0x36 - int16u: AFAreaHeight? (50)
+    #  (AF area positions above give the top-left coordinates of the AF area in the
+    #   AF frame. Increasing Y is downwards, and the AF frame size is about 1280x256)
+);
+
 # Olympus raw information tags (ref 6)
 %Image::ExifTool::Olympus::RawInfo = (
     WRITE_PROC => \&Image::ExifTool::Exif::WriteExif,
     CHECK_PROC => \&Image::ExifTool::Exif::CheckExif,
-    NOTES => 'These tags are found only in ORF images of some models (ie. C8080WZ).',
+    NOTES => 'These tags are found only in ORF images of some models (eg. C8080WZ).',
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
     0x000 => {
@@ -2809,59 +3302,15 @@
         Count => 4,
     },
-    0x100 => {
-        Name => 'WB_RBLevelsUsed',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x110 => {
-        Name => 'WB_RBLevelsAuto',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x120 => {
-        Name => 'WB_RBLevelsShade',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x121 => {
-        Name => 'WB_RBLevelsCloudy',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x122 => {
-        Name => 'WB_RBLevelsFineWeather',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x123 => {
-        Name => 'WB_RBLevelsTungsten',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x124 => {
-        Name => 'WB_RBLevelsEveningSunlight',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x130 => {
-        Name => 'WB_RBLevelsDaylightFluor',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x131 => {
-        Name => 'WB_RBLevelsDayWhiteFluor',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x132 => {
-        Name => 'WB_RBLevelsCoolWhiteFluor',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x133 => {
-        Name => 'WB_RBLevelsWhiteFluorescent',
-        Writable => 'int16u',
-        Count => 2,
-    },
+    0x100 => { Name => 'WB_RBLevelsUsed',           Writable => 'int16u', Count => 2 },
+    0x110 => { Name => 'WB_RBLevelsAuto',           Writable => 'int16u', Count => 2 },
+    0x120 => { Name => 'WB_RBLevelsShade',          Writable => 'int16u', Count => 2 },
+    0x121 => { Name => 'WB_RBLevelsCloudy',         Writable => 'int16u', Count => 2 },
+    0x122 => { Name => 'WB_RBLevelsFineWeather',    Writable => 'int16u', Count => 2 },
+    0x123 => { Name => 'WB_RBLevelsTungsten',       Writable => 'int16u', Count => 2 },
+    0x124 => { Name => 'WB_RBLevelsEveningSunlight',Writable => 'int16u', Count => 2 },
+    0x130 => { Name => 'WB_RBLevelsDaylightFluor',  Writable => 'int16u', Count => 2 },
+    0x131 => { Name => 'WB_RBLevelsDayWhiteFluor',  Writable => 'int16u', Count => 2 },
+    0x132 => { Name => 'WB_RBLevelsCoolWhiteFluor', Writable => 'int16u', Count => 2 },
+    0x133 => { Name => 'WB_RBLevelsWhiteFluorescent',Writable => 'int16u', Count => 2 },
     0x200 => {
         Name => 'ColorMatrix2',
@@ -2876,18 +3325,7 @@
     # 0x300 => sharpness-related
     # 0x301 => list of sharpness-related values
-    0x310 => {
-        Name => 'CoringFilter',
-        Writable => 'int16u',
-    },
-    0x311 => {
-        Name => 'CoringValues',
-        Writable => 'int16u',
-        Count => 11,
-    },
-    0x600 => {
-        Name => 'BlackLevel2',
-        Writable => 'int16u',
-        Count => 4,
-    },
+    0x310 => { Name => 'CoringFilter',      Writable => 'int16u' },
+    0x311 => { Name => 'CoringValues',      Writable => 'int16u', Count => 11 },
+    0x600 => { Name => 'BlackLevel2',       Writable => 'int16u', Count => 4 },
     0x601 => {
         Name => 'YCbCrCoefficients',
